<template>
    <Header :page="'Games'"></Header>
    <div class="content">
        <div v-if="game && game.picture && game.name" class="game">
            <div class="border-round-md" id="picture" :style="{ 'backgroundImage': `url(http://localhost:3000/files/${game.picture})`}"></div>
            <h2>{{ game.name }}</h2>
            <div class="flex align-center justify-content-center">
                <div class="w-15rem">
                    <InputText class="w-9 h-3rem" v-model="code" @keyup.enter="joinRoom"></InputText>
                    <Button class="w-3 h-3rem" label="Join" @click="joinRoom"></Button>
                </div>
                <p class="ml-4 mr-4">OR</p>
                <Button v-if="!roomName" class="w-15rem h-3rem" label="Create game" @click="create"></Button>
                <div v-if="roomName" class="w-15rem">
                    <InputText class="w-9 h-3rem" v-model="roomName" @keyup.enter="createRoom"></InputText>
                    <Button class="w-3 h-3rem" label="Create" @click="createRoom"></Button>
                </div>
            </div>
        </div>
        <ProgressSpinner v-if="!game || !game.picture || !game.name" />
    </div>
</template>

<script>
import Header from "../components/Header.vue";
import ProgressSpinner from 'primevue/progressspinner';
import Button from 'primevue/button';
import InputText from 'primevue/inputtext';

export default {
    name: 'changeUsername',
    data() {
        return {
            game: null,
            code: null,
            roomName: null,
        }
    },
    components: {
        Header,
        ProgressSpinner,
        Button,
        InputText
    },
    methods: {
        getGame(id) {
            fetch(`http://localhost:3000/api/get-game/${id}`,
            {
                method: 'GET',
                headers: {
                    'Authorization': `Bearer ${localStorage.getItem('token')}`
                }
            })
            .then(r => r.json())
            .then(res => {
                this.game = res;
            })
        },
        createRoom() {
            fetch(`http://localhost:3000/api/rooms`,
            {
                method: 'POST',
                headers: {
                    'Content-Type': 'application/json',
                    'Authorization': `Bearer ${localStorage.getItem('token')}`
                },
                body: JSON.stringify({
                    name: this.roomName,
                    game: this.game.id
                })
            })
            .then(r => r.json())
            .then(res => {
                if(res.status && res.status === 200) {
                    console.log(res);
                    this.$store.commit("setParty", {name: res.data.name.replace(" ", "").toLowerCase(), id: res.data.room.id})
                    this.$router.push(`/room/${res.data.name.replace(" ", "").toLowerCase()}/${res.data.room.id}`)
                }
            })
        },
        create() {
            this.roomName = `Party of ${this.username}`
        },
        joinRoom() {
            console.log("issou");
        }
    },
    computed: {
        username () {
            return this.$store.state.username;
        },
    },
    mounted() {
        this.getGame(this.$route.params.id)
    }
}
</script>

<style scoped>

.content {
    width: 100%;
    min-height: 100vh;
    display: flex;
    justify-content: center;
    align-items: center;
    flex-direction: column;
    background: rgb(0, 6, 24);
    background-size: cover;
}

.game {
    height: 70vh;
    display: flex;
    flex-direction: column;
    justify-content: space-between;
}

.game > div:first-child {
    width: 40rem;
    max-width: 95vw;
    height: 20rem;
    background-size: cover;
}

.game h2 {
    font-size: 3rem;
    color: gold;
}

.game p {
    font-size: 2.3rem;
    color: rgb(7, 183, 206);
}

</style>